unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, math, MMSystem;

type

  { TFoAblak }

  TFoAblak = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ellensegkirakas;
    procedure FormPaint(Sender: TObject);
    procedure palyafrissites(Sender: TObject);
    procedure jatekosserul(ennyivel: byte);
    procedure hanglejatszas(hang: string);
    function utkell(lovxhely,lovyhely: integer): byte;
    function ponttav(x1,y1,x2,y2: integer): integer;
    function pontirany(x1,y1,x2,y2: integer): word;
    function utkelllovjat(elllovxhely,elllovyhely: integer): byte;
    function utkcuccjat(ittx,itty: integer; cuccneve: string): boolean;
  private
    { private declarations }
  public
    { public declarations }
  end;
 type TJatekEleme=class(TObject)
  private
  public
    xhely,yhely,celx,cely,mozgirany: integer;
    kepe: TBitmap;
    neve: string;
    energia,alkepe,alkepvaltoseb: byte;
    constructor letrehoz(xhelyitt,yhelyitt: longint; kepeitt: Tbitmap);
end;

var
  FoAblak: TFoAblak;
  jatjobbra,jatbalra,jatekoslo,jatlohet,foellvan,kerdezkilep,mutatnyert,mutatveszt: boolean;
  jatlovkep,htkep,foellkep,cimhtkep,elllovkep,cimfeliratkep,kilepfeliratkep,nyertfeliratkep,vesztfeliratkep: Tbitmap;
  jatekos,foellenseg: TJatekEleme;
  lovedektomb,ellensegtomb,robbanastomb,szikratomb,elllovtomb,jatcucctomb: array of TJatekEleme;
  jatlovidozito,jatalkepvalto,jatalkepdb,szint,ellmozgidozito,ellensegdb,jateletei,jatallapot,jatcuccdb,lovedekdb,robbanasdb,szikradb,elllovdb: byte;
  jatekoskep,jatekoskepbal,jatekoskepjobb: array [0..3] of TBitmap;
  jatekosallapota: string;
  ellensegkepe: array [1..4] of TBitmap;
  robbkepe: array [1..7] of TBitmap;
  jatenergiakepe,jateletekepe: array [0..1] of TBitmap;
  palyafrissito: TTimer;
  hangbuffer: array [0..255] of Char;
  hangero: Dword;

implementation

{$R *.lfm}
constructor TJatekEleme.letrehoz(xhelyitt,yhelyitt: longint; kepeitt: Tbitmap);
begin
        xhely:=xhelyitt;
        yhely:=yhelyitt;
        kepe:=kepeitt;
end;

{ TFoAblak }

procedure TFoAblak.ellensegkirakas;
var hely: integer;
   ellmozgirany: shortint;
begin
       hely:=1;
       ellensegdb:=0;
       if round(random(2))=1 then ellmozgirany:=-4 else ellmozgirany:=4;
       repeat
             setlength(ellensegtomb,ellensegdb+1);
             ellensegtomb[ellensegdb]:=TJatekEleme.Letrehoz(hely,-ellensegkepe[szint].height,ellensegkepe[szint]);
             ellensegtomb[ellensegdb].mozgirany:=ellmozgirany;
             ellensegtomb[ellensegdb].energia:=szint;
             hely:=hely+2*ellensegkepe[szint].width;
             inc(ellensegdb);
       until (hely>=FoAblak.ClientWidth-ellensegkepe[szint].width) or (ellensegdb>250);
end;

procedure TFoAblak.hanglejatszas(hang: string);
begin
    mciSendString(PChar('play '+hang), hangbuffer, 255, 0);
end;

procedure TFoAblak.FormPaint(Sender: TObject);
var i: byte;
begin
     case jatallapot of
      0: begin
         Foablak.Canvas.StretchDraw(Rect(0, 0, ClientWidth, ClientHeight), cimhtkep);
         Foablak.Canvas.Draw(ClientWidth div 2-cimfeliratkep.width div 2,ClientHeight div 2-cimfeliratkep.height div 2,cimfeliratkep);
      end;
      1: begin
         Foablak.Canvas.StretchDraw(Rect(0, 0, ClientWidth, ClientHeight), htkep);
        case jatekosallapota of
              'bejon','kimegy': begin
                            Foablak.Canvas.Draw(Jatekos.xhely,Jatekos.yhely,jatekoskep[jatalkepdb]);
                       end;
              'harcol': begin
                             if jatbalra=true then Foablak.Canvas.Draw(Jatekos.xhely,Jatekos.yhely,jatekoskepbal[jatalkepdb])
                             else if jatjobbra=true then Foablak.Canvas.Draw(Jatekos.xhely,Jatekos.yhely,jatekoskepjobb[jatalkepdb])
                             else Foablak.Canvas.Draw(Jatekos.xhely,Jatekos.yhely,jatekoskep[jatalkepdb]);
                             Foablak.Canvas.TextOut(1,ClientHeight-12,'ENERGIA:');
                             FoAblak.Canvas.Rectangle(FoAblak.Canvas.TextWidth('ENERGIA')+2,ClientHeight-12,Jatekos.energia,ClientHeight);
                             Foablak.Canvas.TextOut(ClientWidth div 2,ClientHeight-12,'Életek / Lives: '+inttostr(jateletei));
                             Foablak.Canvas.TextOut(ClientWidth-FoAblak.Canvas.TextWidth('Szint / Level: '+inttostr(szint))-2,ClientHeight-12,'Szint / Level: '+inttostr(szint));
              end;
       end;

       if ellensegdb>0 then
       begin
          i:=0;
          while i<=ellensegdb-1 do
          begin
              if ellensegtomb[i]<>nil then Foablak.Canvas.Draw(ellensegtomb[i].xhely,ellensegtomb[i].yhely,ellensegtomb[i].kepe);
              inc(i);
          end;
       end;

       if lovedekdb>0 then
       begin
             i:=0;
             while i<=lovedekdb-1 do
             begin
              if lovedektomb[i]<>nil then Foablak.Canvas.Draw(lovedektomb[i].xhely,lovedektomb[i].yhely,lovedektomb[i].kepe);
              inc(i);
             end;
        end;

       if elllovdb>0 then
       begin
             i:=0;
             while i<=elllovdb-1 do
             begin
              if elllovtomb[i]<>nil then Foablak.Canvas.Draw(elllovtomb[i].xhely,elllovtomb[i].yhely,elllovkep);
              inc(i);
             end;
        end;

       if foellvan=true then
       begin
           FoAblak.Canvas.Draw(foellenseg.xhely,foellenseg.yhely,foellkep);
           FoAblak.Canvas.Rectangle((ClientWidth div 2)-foellenseg.energia div 2,2,(ClientWidth div 2)+foellenseg.energia div 2,12);
       end;

       if robbanasdb>0 then
       begin
             i:=0;
             while i<=robbanasdb-1 do
             begin
              if robbanastomb[i]<>nil then Foablak.Canvas.Draw(robbanastomb[i].xhely,robbanastomb[i].yhely,robbkepe[robbanastomb[i].alkepe]);
              inc(i);
             end;
       end;

       if szikradb>0 then
       begin
             i:=0;
             while i<=szikradb-1 do
             begin
              if szikratomb[i]<>nil then Foablak.Canvas.Rectangle(szikratomb[i].xhely,szikratomb[i].yhely,szikratomb[i].xhely+round(random(5)),szikratomb[i].yhely+round(random(5)));
              inc(i);
             end;
       end;

       if jatcuccdb>0 then
       begin
             i:=0;
             while i<=jatcuccdb-1 do
             begin
              if jatcucctomb[i]<>nil then
              begin
                   case jatcucctomb[i].neve of
                         'pluszenergia': Foablak.Canvas.Draw(jatcucctomb[i].xhely,jatcucctomb[i].yhely,jatenergiakepe[jatcucctomb[i].alkepe]);
                         'pluszelet': Foablak.Canvas.Draw(jatcucctomb[i].xhely,jatcucctomb[i].yhely,jateletekepe[jatcucctomb[i].alkepe]);
                   end;
              end;
              inc(i);
             end;
       end;

       if kerdezkilep=true then Foablak.Canvas.Draw(ClientWidth div 2-kilepfeliratkep.width div 2,ClientHeight div 2-kilepfeliratkep.height div 2,kilepfeliratkep);
       if mutatnyert=true then Foablak.Canvas.Draw(ClientWidth div 2-nyertfeliratkep.width div 2,ClientHeight div 2-nyertfeliratkep.height div 2,nyertfeliratkep);
       if mutatveszt=true then Foablak.Canvas.Draw(ClientWidth div 2-vesztfeliratkep.width div 2,ClientHeight div 2-vesztfeliratkep.height div 2,vesztfeliratkep);
     end;
  end;
end;

procedure TFoAblak.jatekosserul(ennyivel: byte);
begin
  if jatekos.energia-ennyivel<1 then
  begin
      jateletei:=jateletei-1;
      hanglejatszas('hangok\robbanas.wav');
      setlength(robbanastomb,robbanasdb+1);
      robbanastomb[robbanasdb]:=TJatekEleme.letrehoz(jatekos.xhely,jatekos.yhely,robbkepe[1]);
      robbanastomb[robbanasdb].alkepe:=1;
      robbanastomb[robbanasdb].alkepvaltoseb:=5;
      inc(robbanasdb);
      if jateletei>0 then
      begin
          jatekos.xhely:=ClientWidth div 2;
          jatekos.yhely:=ClientHeight+jatekoskep[0].height;
          jatekos.energia:=100;
          jatekosallapota:='bejon';
      end
      else mutatveszt:=true;
  end
  else jatekos.energia:=jatekos.energia-ennyivel;
end;

function TFoAblak.utkcuccjat(ittx,itty: integer; cuccneve: string): boolean;
begin
  if (ittx>=Jatekos.xhely) and (ittx<=Jatekos.xhely+jatekoskep[0].width) and (itty>=Jatekos.yhely) and (itty<=Jatekos.yhely+jatekoskep[0].height) then
  begin
       hanglejatszas('hangok\felvesz.wav');
       case cuccneve of
             'pluszenergia': begin
               if jatekos.energia+50<=100 then jatekos.energia:=jatekos.energia+50
               else jatekos.energia:=100;
             end;
             'pluszelet': begin
               jateletei:=jateletei+1;
             end;
       end;
       utkcuccjat:=true;
  end
  else utkcuccjat:=false;
end;

function TFoAblak.utkelllovjat(elllovxhely,elllovyhely: integer): byte;
var eredmeny,sz: byte;
begin
  eredmeny:=0;
  if jatekosallapota='harcol' then
  begin
    if (elllovxhely>=Jatekos.xhely) and (elllovxhely<=Jatekos.xhely+jatekoskep[0].width) and (elllovyhely>=Jatekos.yhely) and (elllovyhely<=Jatekos.yhely+jatekoskep[0].height) then
    begin
      hanglejatszas('hangok\utkozes.wav');
      for sz:=0 to 9 do
      begin
          setlength(szikratomb,szikradb+1);
          szikratomb[szikradb]:=TJatekEleme.letrehoz(elllovxhely+round(random(20)),elllovyhely+round(random(20)),nil);
          szikratomb[szikradb].alkepvaltoseb:=10;
          inc(szikradb);
      end;
      jatekosserul(25);
      eredmeny:=1;
    end;
  end;
  utkelllovjat:=eredmeny;
end;

function TFoAblak.utkell(lovxhely,lovyhely: integer): byte;
var i,j,sz,utkobj: byte;
begin
     utkobj:=0;
     if ellensegdb>0 then
     begin
        i:=0;
        while i<=ellensegdb-1 do
        begin
             if ellensegtomb[i]<>nil then
             begin
                if ((lovxhely>=ellensegtomb[i].xhely) and (lovxhely<=ellensegtomb[i].xhely+ellensegkepe[szint].width)) and (abs(lovyhely-ellensegtomb[i].yhely)<ellensegkepe[szint].height) then
                begin
                   utkobj:=1;
                   dec(ellensegtomb[i].energia);
                   if ellensegtomb[i].energia<=0 then
                   begin
                        hanglejatszas('hangok\robbanas.wav');
                        case round(random(10)) of
                             1: begin
                                setlength(jatcucctomb,jatcuccdb+1);
                                jatcucctomb[jatcuccdb]:=TJatekEleme.letrehoz(ellensegtomb[i].xhely,ellensegtomb[i].yhely,jatenergiakepe[0]);
                                jatcucctomb[jatcuccdb].alkepe:=0;
                                jatcucctomb[jatcuccdb].alkepvaltoseb:=5;
                                jatcucctomb[jatcuccdb].neve:='pluszenergia';
                                inc(jatcuccdb);
                             end;
                             2: begin
                                setlength(jatcucctomb,jatcuccdb+1);
                                jatcucctomb[jatcuccdb]:=TJatekEleme.letrehoz(ellensegtomb[i].xhely,ellensegtomb[i].yhely,jateletekepe[0]);
                                jatcucctomb[jatcuccdb].alkepe:=0;
                                jatcucctomb[jatcuccdb].alkepvaltoseb:=5;
                                jatcucctomb[jatcuccdb].neve:='pluszelet';
                                inc(jatcuccdb);
                             end;
                        end;
                        setlength(robbanastomb,robbanasdb+1);
                        robbanastomb[robbanasdb]:=TJatekEleme.letrehoz(ellensegtomb[i].xhely,ellensegtomb[i].yhely,robbkepe[1]);
                        robbanastomb[robbanasdb].alkepe:=1;
                        robbanastomb[robbanasdb].alkepvaltoseb:=5;
                        inc(robbanasdb);
                        freeandnil(ellensegtomb[i]);
                        if i=ellensegdb-1 then
                           dec(ellensegdb)
                        else
                        begin
                             for j:=i+1 to ellensegdb-1 do
                                 ellensegtomb[j-1]:=ellensegtomb[j];
                             dec(ellensegdb);
                             dec(i);
                        end;
                        if ellensegdb<=0 then
                        begin
                             if szint<4 then
                             begin
                                  szint:=szint+1;
                                  ellensegkirakas;
                             end
                             else
                             begin
                                  foellenseg:=TJatekEleme.Letrehoz(clientwidth div 2,-foellkep.height,foellkep);
                                  foellenseg.energia:=100;
                                  foellenseg.celx:=round(random(ClientWidth-foellkep.width));
                                  foellenseg.cely:=round(random(ClientHeight-foellkep.height));
                                  foellenseg.mozgirany:=pontirany(foellenseg.xhely,foellenseg.yhely,foellenseg.celx,foellenseg.cely);
                                  foellvan:=true;
                             end;
                        end;
                   end;
                   for sz:=0 to 9 do
                   begin
                        setlength(szikratomb,szikradb+1);
                        szikratomb[szikradb]:=TJatekEleme.letrehoz(lovxhely+round(random(20)),lovyhely+round(random(20)),nil);
                        szikratomb[szikradb].alkepvaltoseb:=10;
                        inc(szikradb);
                   end;
                   utkell:=utkobj;
                end;
              end;
             inc(i);
        end;
        utkell:=utkobj;
     end
     else if foellvan=true then
     begin
           if ((lovxhely>=foellenseg.xhely) and (lovxhely<=foellenseg.xhely+foellkep.width)) and (abs(lovyhely-foellenseg.yhely)<foellkep.height) then
           begin
              dec(foellenseg.energia,2);
              if foellenseg.energia<=0 then
              begin
                 hanglejatszas('hangok\robbanas.wav');
                 for i:=0 to 9 do
                 begin
                   setlength(robbanastomb,robbanasdb+1);
                   robbanastomb[robbanasdb]:=TJatekEleme.letrehoz(foellenseg.xhely+round(random(foellkep.width)),foellenseg.yhely+round(random(foellkep.height)),robbkepe[1]);
                   robbanastomb[robbanasdb].alkepe:=1;
                   robbanastomb[robbanasdb].alkepvaltoseb:=5;
                   inc(robbanasdb);
                 end;
                 freeandnil(foellenseg);
                 foellvan:=false;
                 jatekosallapota:='kimegy';
              end
              else begin
                 foellenseg.celx:=round(random(ClientWidth-foellkep.width));
                 foellenseg.cely:=round(random(ClientHeight-foellkep.height));
                 foellenseg.mozgirany:=pontirany(foellenseg.xhely,foellenseg.yhely,foellenseg.celx,foellenseg.cely);
              end;
              for sz:=0 to 9 do
              begin
                        setlength(szikratomb,szikradb+1);
                        szikratomb[szikradb]:=TJatekEleme.letrehoz(lovxhely+round(random(20)),lovyhely+round(random(20)),nil);
                        szikratomb[szikradb].alkepvaltoseb:=10;
                        inc(szikradb);
              end;
              utkobj:=1;
              utkell:=utkobj;
           end else utkell:=utkobj;
     end else utkell:=utkobj;
end;

function TFoAblak.ponttav(x1,y1,x2,y2: integer): integer;
begin
        ponttav:=round(sqr((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
end;

function TFoablak.pontirany(x1,y1,x2,y2: integer): word;
var szam: integer;
begin
    szam:=round(arctan2(y2-y1,x2-x1));
    if szam<0 then
            szam:=round(szam+2*pi);
    pontirany:=round(360-(szam*180)/pi);
end;

procedure TFoAblak.palyafrissites(Sender: TObject);
var i,j: byte;
    radianbanirany: real;
begin
  case jatallapot of
      1: if (kerdezkilep=false) and (mutatnyert=false) and (mutatveszt=false) then begin
        if jatalkepvalto>0 then jatalkepvalto:=jatalkepvalto-1
        else
        begin
          jatalkepvalto:=10;
          if jatalkepdb+1<=3 then jatalkepdb:=jatalkepdb+1 else jatalkepdb:=0;
        end;

        case jatekosallapota of
              'bejon': begin
                            Jatekos.yhely:=Jatekos.yhely-4;
                            if Jatekos.yhely<ClientHeight-jatekoskep[0].height-20 then
                               jatekosallapota:='harcol';
                       end;
              'kimegy': begin
                             Jatekos.yhely:=Jatekos.yhely-8;
                             if Jatekos.yhely<0 then
                             begin
                               jatekosallapota:='nincs';
                               freeandnil(jatekos);
                               mutatnyert:=true;
                             end;
                        end;
              'harcol': begin
                             if jatjobbra=true then
                             begin
                               if Jatekos.xhely+jatekoskep[0].Width<ClientWidth then Jatekos.xhely:=Jatekos.xhely+4;
                             end;
                             if jatbalra=true then
                             begin
                                if Jatekos.xhely-2>0 then Jatekos.xhely:=Jatekos.xhely-4;
                             end;
                             if (jatekoslo=true) and (jatlohet=true) then
                             begin
                                hanglejatszas('hangok\loves.wav');
                                setlength(lovedektomb,lovedekdb+1);
                                lovedektomb[lovedekdb]:=TJatekEleme.letrehoz(Jatekos.xhely+jatekoskep[0].Width div 2,Jatekos.yhely,jatlovkep);
                                inc(lovedekdb);
                                jatlovidozito:=48;
                                jatlohet:=false;
                             end;
              end;
       end;

       if ellensegdb>0 then
       begin
          i:=0;
          while i<=ellensegdb-1 do
          begin
              if ellensegtomb[i]<>nil then
              begin
                 if (ellensegtomb[i].xhely+ellensegtomb[i].mozgirany>=ClientWidth-ellensegkepe[szint].width) or (ellensegtomb[i].xhely+ellensegtomb[i].mozgirany<=1) then
                 begin
                          if ellensegtomb[i].yhely+ellensegkepe[szint].height<ClientHeight-jatekoskep[0].height-20 then
                             ellensegtomb[i].yhely:=ellensegtomb[i].yhely+ellensegkepe[szint].height;
                          ellensegtomb[i].mozgirany:=-ellensegtomb[i].mozgirany;
                 end
                 else
                 begin
                        with ellensegtomb[i] do
                        begin
                          xhely:=xhely+mozgirany; //a mozgirany itt sebesség is, ami 4 vagy -4
                          if (round(random(100))=1) and (ellensegdb<szint+1) then
                          begin
                             hanglejatszas('hangok\loves.wav');
                             setlength(elllovtomb,elllovdb+1);
                             elllovtomb[elllovdb]:=TJatekEleme.letrehoz(xhely+ellensegkepe[szint].Width div 2,yhely+ellensegkepe[szint].Height div 2,elllovkep);
                             inc(elllovdb);
                          end;
                        end;
                 end;
                 if (abs(jatekos.xhely-ellensegtomb[i].xhely)<ellensegkepe[szint].width) and (abs(jatekos.yhely-ellensegtomb[i].yhely)<ellensegkepe[szint].height) then
                 begin
                         hanglejatszas('hangok\robbanas.wav');
                         setlength(robbanastomb,robbanasdb+1);
                         robbanastomb[robbanasdb]:=TJatekEleme.letrehoz(ellensegtomb[i].xhely,ellensegtomb[i].yhely,robbkepe[1]);
                         robbanastomb[robbanasdb].alkepe:=1;
                         robbanastomb[robbanasdb].alkepvaltoseb:=5;
                         inc(robbanasdb);
                         freeandnil(ellensegtomb[i]);
                         if i=ellensegdb-1 then
                            dec(ellensegdb)
                         else
                         begin
                              for j:=i+1 to ellensegdb-1 do
                                  ellensegtomb[j-1]:=ellensegtomb[j];
                              dec(ellensegdb);
                              dec(i);
                         end;
                         jatekosserul(50);
                         if ellensegdb<=0 then
                         begin
                                  if szint<4 then
                                  begin
                                       szint:=szint+1;
                                       ellensegkirakas;
                                  end
                                  else
                                  begin
                                   foellenseg:=TJatekEleme.Letrehoz(clientwidth div 2,-foellkep.height,foellkep);
                                   foellenseg.energia:=100;
                                   foellenseg.celx:=round(random(ClientWidth));
                                   foellenseg.cely:=round(random(ClientHeight));
                                   foellenseg.mozgirany:=pontirany(foellenseg.xhely,foellenseg.yhely,foellenseg.celx,foellenseg.cely);
                                   foellvan:=true;
                                  end;
                         end;
                 end;
            end;
            inc(i);
          end;
       end;

       if lovedekdb>0 then
       begin
             i:=0;
             while i<=lovedekdb-1 do
             begin
              if lovedektomb[i]<>nil then
              begin
                  lovedektomb[i].yhely:=lovedektomb[i].yhely-8;
                  if (lovedektomb[i].yhely<10) or (utkell(lovedektomb[i].xhely,lovedektomb[i].yhely)<>0) then
                  begin
                       freeandnil(lovedektomb[i]);
                       if i=lovedekdb-1 then
                          dec(lovedekdb)
                       else
                       begin
                            for j:=i+1 to lovedekdb-1 do
                                lovedektomb[j-1]:=lovedektomb[j];
                            dec(lovedekdb);
                            dec(i);
                       end;
                  end;
                end;
                inc(i);
             end;
        end;

       if elllovdb>0 then
       begin
             i:=0;
             while i<=elllovdb-1 do
             begin
              if elllovtomb[i]<>nil then
              begin
                  elllovtomb[i].yhely:=elllovtomb[i].yhely+8;
                  if (elllovtomb[i].yhely>=ClientHeight) or (utkelllovjat(elllovtomb[i].xhely,elllovtomb[i].yhely)<>0) then
                  begin
                       freeandnil(elllovtomb[i]);
                       if i=elllovdb-1 then
                          dec(elllovdb)
                       else
                       begin
                            for j:=i+1 to elllovdb-1 do
                                elllovtomb[j-1]:=elllovtomb[j];
                            dec(elllovdb);
                            dec(i);
                       end;
                  end;
                end;
                inc(i);
             end;
        end;

       if jatcuccdb>0 then
       begin
             i:=0;
             while i<=jatcuccdb-1 do
             begin
              if jatcucctomb[i]<>nil then
              begin
                  if jatcucctomb[i].alkepvaltoseb<1 then
                  begin
                       if jatcucctomb[i].alkepe=0 then jatcucctomb[i].alkepe:=1 else jatcucctomb[i].alkepe:=0;
                       jatcucctomb[i].alkepvaltoseb:=5;
                  end
                  else jatcucctomb[i].alkepvaltoseb:=jatcucctomb[i].alkepvaltoseb-1;
                  jatcucctomb[i].yhely:=jatcucctomb[i].yhely+8;
                  if (jatcucctomb[i].yhely>=ClientHeight) or (utkcuccjat(jatcucctomb[i].xhely,jatcucctomb[i].yhely,jatcucctomb[i].neve)=true) then
                  begin
                       freeandnil(jatcucctomb[i]);
                       if i=jatcuccdb-1 then
                          dec(jatcuccdb)
                       else
                       begin
                            for j:=i+1 to jatcuccdb-1 do
                                jatcucctomb[j-1]:=jatcucctomb[j];
                            dec(jatcuccdb);
                            dec(i);
                       end;
                  end;
                end;
                inc(i);
             end;
        end;

       if foellvan=true then
       begin
           radianbanirany:=(360-foellenseg.mozgirany)*pi/180;
           foellenseg.xhely:=foellenseg.xhely+round(cos(radianbanirany))*4; //4 a sebessége
           foellenseg.yhely:=foellenseg.yhely+round(sin(radianbanirany))*4;
           if round(random(100))=1 then
           begin
             setlength(elllovtomb,elllovdb+1);
             elllovtomb[elllovdb]:=TJatekEleme.letrehoz(foellenseg.xhely+foellkep.Width div 2,foellenseg.yhely+foellkep.height div 2,elllovkep);
             inc(elllovdb);
           end;
           if (Jatekos.xhely>=foellenseg.xhely) and (Jatekos.xhely<=foellenseg.xhely+foellkep.width) and (Jatekos.yhely>=foellenseg.yhely) and (Jatekos.yhely<=foellenseg.yhely+foellkep.height) then
              jatekosserul(2);
           if ponttav(foellenseg.xhely,foellenseg.yhely,foellenseg.celx,foellenseg.cely)<=4 then
           begin
                foellenseg.celx:=round(random(ClientWidth-foellkep.width));
                foellenseg.cely:=round(random(ClientHeight-foellkep.height));
                foellenseg.mozgirany:=pontirany(foellenseg.xhely,foellenseg.yhely,foellenseg.celx,foellenseg.cely);
           end;
       end;

       if robbanasdb>0 then
       begin
             i:=0;
             while i<=robbanasdb-1 do
             begin
              if robbanastomb[i]<>nil then
              begin
                  if robbanastomb[i].alkepe>6 then
                  begin
                       freeandnil(robbanastomb[i]);
                       if i=robbanasdb-1 then
                            dec(robbanasdb)
                       else
                       begin
                            for j:=i+1 to robbanasdb-1 do
                                robbanastomb[j-1]:=robbanastomb[j];
                            dec(robbanasdb);
                            dec(i);
                       end;
                  end
                  else
                  begin
                    if robbanastomb[i].alkepvaltoseb>0 then dec(robbanastomb[i].alkepvaltoseb)
                    else
                    begin
                            robbanastomb[i].alkepvaltoseb:=5;
                            inc(robbanastomb[i].alkepe);
                    end;
                  end;
              end;
              inc(i);
             end;
       end;

       if szikradb>0 then
       begin
             i:=0;
             while i<=szikradb-1 do
             begin
              if szikratomb[i]<>nil then
              begin
                  if szikratomb[i].alkepvaltoseb<1 then
                  begin
                       freeandnil(szikratomb[i]);
                       if i=szikradb-1 then
                            dec(szikradb)
                       else
                       begin
                            for j:=i+1 to szikradb-1 do
                                szikratomb[j-1]:=szikratomb[j];
                            dec(szikradb);
                            dec(i);
                       end;
                  end
                  else
                  begin
                    dec(szikratomb[i].alkepvaltoseb);
                  end;
              end;
              inc(i);
             end;
       end;

       if jatlovidozito>0 then dec(jatlovidozito) else jatlohet:=true;
     end;
  end;
  with canvas do invalidate;
end;

procedure TFoAblak.FormCreate(Sender: TObject);
var i: byte;
begin
  BorderStyle:=bsSingle;
  WindowState:=wsFullScreen;
  width:=Screen.width;
  height:=Screen.height;
  jatjobbra:=false;
  jatbalra:=false;
  jatekoslo:=false;
  jatlohet:=true;
  jatalkepdb:=0;
  for i:=0 to 3 do
  begin
   jatekoskep[i]:=TBitMap.Create;
   jatekoskep[i].LoadFromFile('kepek\urhajofel'+inttostr(i+1)+'.bmp');
   jatekoskep[i].transparent:=true;
   jatekoskepbal[i]:=TBitMap.Create;
   jatekoskepbal[i].LoadFromFile('kepek\urh_bal'+inttostr(i)+'.bmp');
   jatekoskepbal[i].transparent:=true;
   jatekoskepjobb[i]:=TBitMap.Create;
   jatekoskepjobb[i].LoadFromFile('kepek\urh_jobb'+inttostr(i)+'.bmp');
   jatekoskepjobb[i].transparent:=true;
  end;
  jatalkepvalto:=10;
  jatlovkep:=TBitMap.Create;
  jatlovkep.LoadFromFile('kepek\lovedek.bmp');
  jatlovkep.transparent:=true;
  elllovkep:=TBitMap.Create;
  elllovkep.LoadFromFile('kepek\ell_lov.bmp');
  elllovkep.transparent:=true;
  lovedekdb:=0;
  jatlovidozito:=0;
  htkep := TBitmap.Create;
  htkep.LoadFromFile('kepek\urhatter.bmp');
  cimhtkep:=TBitmap.Create;
  cimhtkep.LoadFromFile('kepek\cimhatter.bmp');
  cimfeliratkep:=TBitmap.Create;
  cimfeliratkep.LoadFromFile('kepek\cimfelirat.bmp');
  cimfeliratkep.transparent:=true;
  kilepfeliratkep:=TBitmap.Create;
  kilepfeliratkep.LoadFromFile('kepek\kilepfelirat.bmp');
  kilepfeliratkep.transparent:=true;
  nyertfeliratkep:=TBitmap.Create;
  nyertfeliratkep.LoadFromFile('kepek\nyertfelirat.bmp');
  nyertfeliratkep.transparent:=true;
  vesztfeliratkep:=TBitmap.Create;
  vesztfeliratkep.LoadFromFile('kepek\vesztfelirat.bmp');
  vesztfeliratkep.transparent:=true;
  for i:=1 to 4 do
  begin
   ellensegkepe[i]:=TBitMap.Create;
   ellensegkepe[i].LoadFromFile('kepek\ell'+inttostr(i)+'.bmp');
   ellensegkepe[i].transparent:=true;
  end;
  for i:=1 to 7 do
  begin
   robbkepe[i]:=TBitMap.Create;
   robbkepe[i].LoadFromFile('kepek\robb'+inttostr(i)+'.bmp');
   robbkepe[i].transparent:=true;
  end;
  for i:=0 to 1 do
  begin
   jatenergiakepe[i]:=TBitmap.Create;
   jatenergiakepe[i].LoadFromFile('kepek\energia'+inttostr(i)+'.bmp');
   jateletekepe[i]:=TBitMap.Create;
   jateletekepe[i].LoadFromFile('kepek\elet'+inttostr(i)+'.bmp');
   jateletekepe[i].transparent:=true;
  end;
  foellkep:=TBitMap.Create;
  foellkep.LoadFromFile('kepek\foell.bmp');
  foellkep.transparent:=true;
  szint:=1;
  robbanasdb:=0;
  ellensegdb:=0;
  szikradb:=0;
  jatcuccdb:=0;
  elllovdb:=0;
  randomize;
  palyafrissito:=TTimer.Create(nil);
  palyafrissito.interval:=24;
  palyafrissito.ontimer:=@palyafrissites;
  kerdezkilep:=false;
  mutatnyert:=false;
  mutatveszt:=false;
  hangero:=20000;
  jatallapot:=0;
end;

procedure TFoAblak.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: byte;
begin
  case key of
       13: if jatallapot=0 then begin
                jatallapot:=1;
                jatekos:=TJatekEleme.letrehoz(ClientWidth div 2,ClientHeight+jatekoskep[0].height,jatekoskep[jatalkepdb]);
                jatekos.energia:=100;
                jatekosallapota:='bejon';
                jateletei:=3;
                foellvan:=false;
                ellensegkirakas;
           end
           else
           if (mutatnyert=true) or (mutatveszt=true) then
           begin
              if szikradb>0 then for i:=0 to szikradb-1 do FreeAndNil(szikratomb[i]);
              if ellensegdb>0 then for i:=0 to ellensegdb-1 do FreeAndNil(ellensegtomb[i]);
              if lovedekdb>0 then for i:=0 to lovedekdb-1 do FreeAndNil(lovedektomb[i]);
              if elllovdb>0 then for i:=0 to elllovdb-1 do FreeAndNil(elllovtomb[i]);
              if robbanasdb>0 then for i:=0 to robbanasdb-1 do FreeAndNil(robbanastomb[i]);
              if foellvan=true then freeandnil(foellenseg);
              mutatnyert:=false;
              mutatveszt:=false;
              szint:=1;
              jatallapot:=0;
           end;
       37: jatbalra:=true;
       39: jatjobbra:=true;
       17: jatekoslo:=true;
       32: jatekoslo:=true;
       27: if jatallapot=0 then begin
                htkep.free;
                cimhtkep.free;
                cimfeliratkep.free;
                kilepfeliratkep.free;
                nyertfeliratkep.free;
                vesztfeliratkep.free;
                jatlovkep.free;
                elllovkep.free;
                for i:=0 to 3 do
                begin
                    jatekoskep[i].free;
                    jatekoskepbal[i].free;
                    jatekoskepjobb[i].free;
                end;
                for i:=1 to 4 do
                    ellensegkepe[i].free;
                for i:=1 to 7 do
                    robbkepe[i].free;
                for i:=0 to 1 do
                begin
                    jatenergiakepe[i].free;
                    jateletekepe[i].free;
                end;
                foellkep.free;
                close();
           end else if (mutatveszt=false) and (mutatnyert=false) then kerdezkilep:=true;
        73,89,105,121: if kerdezkilep=true then
        begin
              if szikradb>0 then for i:=0 to szikradb-1 do FreeAndNil(szikratomb[i]);
              if ellensegdb>0 then for i:=0 to ellensegdb-1 do FreeAndNil(ellensegtomb[i]);
              if lovedekdb>0 then for i:=0 to lovedekdb-1 do FreeAndNil(lovedektomb[i]);
              if elllovdb>0 then for i:=0 to elllovdb-1 do FreeAndNil(elllovtomb[i]);
              if robbanasdb>0 then for i:=0 to robbanasdb-1 do FreeAndNil(robbanastomb[i]);
              if foellvan=true then freeandnil(foellenseg);
              freeandnil(jatekos);
              mutatnyert:=false;
              mutatveszt:=false;
              kerdezkilep:=false;
              szint:=1;
              jatallapot:=0;
        end;
        78,110: if kerdezkilep=true then kerdezkilep:=false;
        50: if hangero+500<=65535 then
        begin
             hangero:=hangero+500;
             waveOutSetVolume(0,hangero);
        end;
        49: if hangero-500>0 then
        begin
          hangero:=hangero-500;
          waveOutSetVolume(0,hangero);
        end;
  end;
end;

procedure TFoAblak.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 case key of
       37: jatbalra:=false;
       39: jatjobbra:=false;
       17: jatekoslo:=false;
       32: jatekoslo:=false;
  end;
end;

end.
